/*
  Copyright (C) 1998-1999 Johan Redestig

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "stdafx.h"
#include "DirectoryFolder.h"
#include "PopupMaker.h"
#include "PopupMenu.h"

#include "HeaderItem.h"


BOOL DirectoryFolder::m_bShowExtension = FALSE;
BOOL DirectoryFolder::m_bAutoSeparator = FALSE;
BOOL DirectoryFolder::m_bUseCaching = FALSE;

DirectoryFolder::DirectoryFolder(char* pszPath, BOOL bDynamic, PopupMaker* pPopupMaker, 
						 char* pszTitle, PopupMenu* pParent): FolderItem(NULL, pszTitle)
{
	m_bDynamic = bDynamic;
  m_szPath[0] = '\0';
  
	if (pszPath != NULL)
    lstrcpy(m_szPath, pszPath);
	m_pPopupMaker = pPopupMaker;
  m_pParent = pParent;

//  GetFolder();
}

void DirectoryFolder::GetFolder()
{
  if (NULL == m_pSubMenu)
	{
		// Lazy loading of folders, do not mess with them untill you 
		// absolutely need to (this is used strictly for "!DirectoryFolders"
		m_pSubMenu = m_pPopupMaker->LoadFolder(m_szPath);
		m_pParent->AddChild(m_pSubMenu);
		m_pSubMenu->SetParent(m_pParent);
  }
}

DirectoryFolder::~DirectoryFolder()
{
  if(m_pSubMenu) delete m_pSubMenu;

	m_pSubMenu = NULL;
}

BOOL DirectoryFolder::Active(BOOL bActivate)
{ 
//	if(m_bActive == bActivate && m_pSubMenu)
//		if(IsWindowVisible(m_pSubMenu->GetWindow()))
//			return bActivate;
	
	if(bActivate)
	{
    if (FALSE != m_bDynamic && NULL != m_pSubMenu)
    {
      BOOL bRemove = FALSE;
      if (FALSE == m_bUseCaching && FALSE == IsWindowVisible(m_pSubMenu->GetWindow()))
        bRemove = TRUE;
      else
		  if (m_pSubMenu->GetContentsChanged())
      {
        bRemove = TRUE;
        m_pPopupMaker->removeFile(m_szPath);
		  }
      if (bRemove)
      {
			  ShowWindow(m_pSubMenu->GetWindow(), SW_HIDE);
			  m_pParent->RemoveChild(m_pSubMenu);
			  delete m_pSubMenu;
        m_pSubMenu = NULL;
      }
    }
    GetFolder();
	}

  if (NULL == m_pSubMenu)
    return (TitleItem::Active(bActivate));

	return FolderItem::Active(bActivate);
}

void DirectoryFolder::Attached(PopupMenu* pMenu)
{
	m_pParent = pMenu;
}
