//#include <windows.h>
#include "stdafx.h"
#include "Re5ources.h"

HICON GetIconFromPath(const char* pszPath)
{
	SHFILEINFO shFileInfo;
  char pszFileName[MAX_PATH] = {0};
	_searchenv(pszPath, "PATH", pszFileName);
	SHGetFileInfo(pszFileName, NULL, &shFileInfo, sizeof(shFileInfo), SHGFI_ICON | SHGFI_SMALLICON);

	if(lstrlen(pszFileName) == 0)
	{
		char pszGuess[MAX_PATH];
		// well... guess that the user has an exe in mind ..
		lstrcpy(pszGuess, pszPath);
		lstrcat(pszGuess, ".exe");
		_searchenv(pszGuess, "PATH", pszFileName);
		SHGetFileInfo(pszFileName, NULL, &shFileInfo, sizeof(shFileInfo), SHGFI_ICON | SHGFI_SMALLICON);
	} 
	return shFileInfo.hIcon;
}

HICON GetIconFromWindow(HWND hWnd, BOOL bBigIcon)
{
   HICON hIcon = NULL;

   int nBigOrSmall = bBigIcon ? ICON_BIG : ICON_SMALL;
   int nBigOrSmall2 = bBigIcon ? GCL_HICON : GCL_HICONSM;

   // try to get the normal icon
   SendMessageTimeout(hWnd, WM_GETICON, nBigOrSmall, 0, 
	   SMTO_ABORTIFHUNG, 1000, (PULONG)&hIcon);

   // if there is none then try to query the icon
   if(!hIcon) SendMessageTimeout(hWnd, WM_QUERYDRAGICON, 
	   nBigOrSmall, 0, SMTO_ABORTIFHUNG, 1000, (PULONG)&hIcon);

   // get the class icon
   if(!hIcon) hIcon = (HICON)GetClassLong(hWnd, nBigOrSmall2);

   //
   if(!hIcon) SendMessageTimeout(hWnd, WM_GETICON, nBigOrSmall, 
	   1, SMTO_ABORTIFHUNG, 1000, (PULONG)&hIcon);

   if(!hIcon) hIcon = (HICON)GetClassLong(hWnd, nBigOrSmall2);
   
   
   return hIcon;
}

BOOL IsAppWindow(HWND hWnd)
{
	BOOL bResult = TRUE;
	LONG nStyle;
	HWND hOwner;
	HWND hParent;

	// if it is a WS_CHILD or not WS_VISIBLE, fail it
	nStyle = GetWindowLong(hWnd, GWL_STYLE);	
	if((nStyle & WS_CHILD) || !(nStyle & WS_VISIBLE))
		bResult = FALSE;

	// if the window is a WS_EX_TOOLWINDOW fail it
	nStyle = GetWindowLong(hWnd, GWL_EXSTYLE);
	if(nStyle & WS_EX_TOOLWINDOW)
		bResult = FALSE;

	// If this has an owner, then only accept this window
	// if the partent is not accepted
	hOwner = GetWindow(hWnd, GW_OWNER);
	if(hOwner && bResult)
		bResult = !IsAppWindow(hOwner);

	// if it has a parent, fail
	hParent = GetParent(hWnd);
	if(hParent)
		bResult = FALSE;

	if(GetWindowLong(hWnd, GWL_USERDATA) == 0x49474541)
		bResult = FALSE;

	return bResult;
}

int GetInetTime(long now)
{
	// and one hour to get GMT+1 (swizz based time :)
	long nDawn = now + 3600; 

	// get number of seconds since midnight
	long nSeconds = nDawn % 86400; 

	// convert the number of seconds to a number 0..1000
	int nInetTime = (int)(nSeconds / 86.4);

	// account for possible overlapp
	if(nInetTime >= 1000)
		nInetTime = 0;
	return nInetTime;
}

void SnappWindow(WINDOWPOS* pwPos, int nDist, BOOL bUseScreenSize)
{
	RECT workArea;
	int nTemp;

	if(bUseScreenSize)
	{
		ZeroMemory(&workArea, sizeof(workArea));
		workArea.right = GetSystemMetrics(SM_CXSCREEN);
		workArea.bottom = GetSystemMetrics(SM_CYSCREEN);
	}
	else
	{
		SystemParametersInfo(SPI_GETWORKAREA, 0, &workArea, 0);
	}

	// left edge
	nTemp = pwPos->x;
	if(nTemp < nDist && nTemp > -nDist)
		pwPos->x = 0;

	// top edge
	nTemp = pwPos->y;
	if(nTemp < nDist && nTemp > -nDist)
		pwPos->y = 0;

	// bottom edge
	nTemp =  workArea.bottom - (pwPos->y + pwPos->cy);
	if(nTemp < nDist && nTemp > -nDist)
		pwPos->y = workArea.bottom - pwPos->cy;

	// right edge
	nTemp = workArea.right - (pwPos->x + pwPos->cx);
	if(nTemp < nDist && nTemp > -nDist) 
		pwPos->x = workArea.right - pwPos->cx;
}

