/*
  Copyright (C) 1998-1999 Johan Redestig
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#if !defined(AFX_SEPARATORITEM_H__D5612516_732D_11D2_B69F_00C0DF466974__INCLUDED_)
#define AFX_SEPARATORITEM_H__D5612516_732D_11D2_B69F_00C0DF466974__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MenuItem.h"

/**
a menu item that implements the !Separator. this is a horizontal line that
can be inserted in the menu. the separatoritem can also be used as a simple
non-activatable and empty item
*/
class SeparatorItem : public MenuItem  
{
public:
	/// constructs a separatir item with decoration
	SeparatorItem();

	/**
	constructs a separator item

	@param bDecoration should the horizontal line be drawn?
	*/
	SeparatorItem(BOOL bDecoration);

	/// destroys the separator item
	virtual ~SeparatorItem();

	/**
	paints the item and the horizontal line on the hdc

	@param hDC handle to the device to be painted on
	*/
	void Paint(HDC hDC);

	/**
	tries to set the activation state of this object, since this
	is a separator it can not be activated

	@return FALSE it can not be activated
	*/
	BOOL Active(BOOL bActive){return FALSE;};

	//LRESULT NcHitTest(int x, int y);
private:
	BOOL m_bDecoration;
};

#endif // !defined(AFX_SEPARATORITEM_H__D5612516_732D_11D2_B69F_00C0DF466974__INCLUDED_)
