/*
  Copyright (C) 1998-1999 Johan Redestig
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#if !defined(AFX_SOLIDPAINTER_H__70DDBB44_76FE_11D2_B6A5_00C0DF466974__INCLUDED_)
#define AFX_SOLIDPAINTER_H__70DDBB44_76FE_11D2_B6A5_00C0DF466974__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Painter.h"

/**
a painter that paints with a solid color. this is used primarely
for efficensy resons
*/
class SolidPainter : public Painter  
{
public:
	/**
	constructs an object with the specific color

	@param c the color to be used for painting
	*/
	SolidPainter(COLORREF c);

	/// destroys the object
	virtual ~SolidPainter();

	/// paints the menuitem with a solid color
	void Paint(MenuItem* pMenuItem, HDC hDC);
private:
	COLORREF m_Color;
	HBRUSH m_hBrush;
	HPEN m_hPen;
};

#endif // !defined(AFX_SOLIDPAINTER_H__70DDBB44_76FE_11D2_B6A5_00C0DF466974__INCLUDED_)
