/*
  Copyright (C) 1998-1999 Johan Redestig
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "stdafx.h"
#include "TitleItem.h"
#include "MenuItem.h"

TitleItem::TitleItem(char* pszTitle)
{
	if(pszTitle != NULL)
	{
		m_pszTitle = strdup(pszTitle);

		// search the string for '&', that is keyboard-shortcuts
		int len = lstrlen(m_pszTitle);
		for(int i=0; i<len; i++)
			if(m_pszTitle[i] == '&' && m_pszTitle[i+1] != '\0')
			{
				int c = islower(m_pszTitle[i+1]) ? 
						_toupper(m_pszTitle[i+1]) : 
						m_pszTitle[i+1];
				SetShortcut(c);
				break;
			}
	}

	m_hIcon = NULL;
}

TitleItem::~TitleItem()
{
	if(m_pszTitle)free(m_pszTitle);
	m_pszTitle = NULL;
}

void TitleItem::Paint(HDC hDC)
{
	RECT r;

	MenuItem::Paint(hDC);

	GetTitleRect(&r);

	DrawText(hDC, m_pszTitle, lstrlen(m_pszTitle), &r, 
		GetDrawTextFormat());

	if(m_bDrawBevel)
		PaintBevel(hDC, m_nTop);
}

void TitleItem::GetTitleRect(RECT* r)
{
	r->top = m_nTop;

  if (GetAlignAllText())
  {
    r->left = GetHeight() + 3 + m_nIndent;//bug: no nLeft here ...
  }
  else
  {
  	r->left = m_hIcon == NULL ? 3 + m_nIndent: GetHeight() + 3 + m_nIndent;//bug: no nLeft here ...
  }
	r->bottom = GetHeight() + m_nTop;
	r->right = GetWidth() -3; //bug: no nLeft here ...
}
